module FC where
import Grappa

call = fc ex 

ex = [("text",[1,2]),("text",[2,3]),("cond",[3,8,4]),("cond",[4,5,6]),
      ("text",[5,7]),("text",[6,7]),("text",[7,3]),("text",[8,9])]

stmts::(Node,Node) -> Grappa 
stmts (n1,n2) = stmt (n1,n2)
stmts (n1,n2) = stmt (n1,n) <*> 
                stmts (n,n2)
                where n free

stmt::(Node,Node) -> Grappa 
stmt (n1,n2) = edge ("text", [n1,n2])
stmt (n1,n2) = edge ("cond", [n1,nno,nyes]) <*>
               stmts (nno,n2) <*> stmts (nyes,n2)
               where nno, nyes free
stmt (n1,n2) = edge ("cond", [n1,n2,nbody]) <*>
               stmts (nbody,n1)
               where nbody free

fc = stmts (n1,n2) <*> eoi where n1,n2 free

--text
--text
--...
--text
genChainFCOfSize n = case n of
                     0 -> []
                     _ -> ("text",[n,n-1]):genChainFCOfSize (n-1)      

--cond
--    cond
--        ...
--           cond
--               text
genCondsFCOfSize n = case n of
                     1 -> [("text",[1,2])]
                     _ -> ("cond",[n,n+1,n-1]):genCondsFCOfSize (n-1)

--text
--cond
--    text
--    cond
--        ...
--           text
--           cond(4,
--               text(1,2)
--size = 2n-1
genMixedFCOfSize n = case n of
                     1 -> [("text",[2,5])]
                     _ -> ("text",[2*n,2*n+1]):("cond",[2*n+1,2*n+3,2*n-2]):genMixedFCOfSize (n-1)
