module Sierpinski where
import Grappa

data Natural = Z | S Natural

s Z (n1,n2,n3) = edge ("line",[n1,n2]) <*> 
                 edge ("line",[n2,n3]) <*>
                 edge ("line",[n3,n1]) 
s (S depth) (n1,n2,n3) = s depth (n1,n4,n5) <*> 
                         s depth (n4,n2,n6) <*>
                         s depth (n5,n6,n3)
                         where n4,n5,n6 free

regSierpinski = s depth (n1,n2,n3) 
                where depth,n1,n2,n3 free
